// $Date:: 2009-10-18 08:03:44 +0900#$
// $Rev: 16 $


#pragma once
#include <windows.h>
#include "avisynth.h"

//==============================================================================
// PNLM
//==============================================================================
class PNLM : public GenericVideoFilter
{
private:
typedef union
{
    __int32 int32 ;
    __int16 int16 [ 2 ] ;
} _weight ;

protected:
    unsigned int Height ;
    unsigned int Width ;
    int Strength ;
    int Threshold1 ;
    int Threshold2 ;
    _weight * pW ;
    BYTE ** FrameCache ;
    int PreFrameNum ;
    int nSrcYPitch ;

public:
	PNLM (PClip _child, int strength, int threshold1, int threshold2, IScriptEnvironment* env);
	~PNLM ();
    PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) ;
};
